/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: CloseList.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_CLOSE_LIST_HPP_
#define _UTILITY_CLOSE_LIST_HPP_

#include "tops/utilities/CloseContainer/CloseContainer.hpp"
#include "tops/utilities/CloseContainer/CloseRelationImpl.hpp"

#include <list>

namespace Utility {

	/**
	 * 密リストテンプレートです。
	 * このテンプレートは、型引数に密コンテナ要素のポインタ型（スマートポインタ可）を必要とします。
	 * 密コンテナ要素のポインタ型に必要となる性質を以下に示します。
     *
     * 1. CloseContainerElement のポインタ（もしくはスマートポインタ）であること。
	 *
	 * この密リストテンプレートは、実装に STL の std::list を利用しています。
	 *
	 * @author Yutaka Ito
	 */
	template<typename PtrType>
	class CloseList : public CloseContainer {
	private:
		typedef std::list<PtrType> ElementList;
		ElementList m_elements;

	public:
		/**
		 * 通常前方反復子型です。
		 */
		typedef typename ElementList::iterator iterator;

		/**
		 * 定数前方反復子型です。
		 */
		typedef typename ElementList::const_iterator const_iterator;

	public:
		/**
		 * リストを構築します。
		 */
		CloseList() {
		}

		/**
		 * リストを破棄します。
		 */
		~CloseList() {
			clear();
		}

	public:
		/**
		 * 空かどうかを判断します。
		 *
		 * @return 空の場合は true、それ以外の場合は false。
		 */
		bool empty() const {
			return m_elements.empty();
		}

		/**
		 * サイズを取得します。
		 *
		 * @return サイズ。
		 */
		size_t size() const {
			return m_elements.size();
		}

		/**
		 * 要素列の先頭を示す反復子を取得します。
		 *
		 * @return 反復子。
		 */
		iterator begin() {
			return m_elements.begin();
		}

		/**
		 * 要素列の先頭を示す定数反復子を取得します。
		 *
		 * @return 定数反復子。
		 */
		const_iterator begin() const {
			return m_elements.begin();
		}

		/**
		 * 要素列の末尾を示す反復子を取得します。
		 *
		 * @return 反復子。
		 */
		iterator end() {
			return m_elements.end();
		}

		/**
		 * 要素列の末尾を示す定数反復子を取得します。
		 *
		 * @return 定数反復子。
		 */
		const_iterator end() const {
			return m_elements.end();
		}

	public:
		/**
		 * 先頭の要素を取得します。
		 *
		 * @return 要素。
		 */
		const PtrType& front() {
			return m_elements.front();
		}

		/**
		 * 末尾の要素を取得します。
		 *
		 * @return 要素。
		 */
		const PtrType& back () {
			return m_elements.back ();
		}

	public:
		/**
		 * 要素を追加します。
		 *
		 * @param i 追加位置を指す反復子。
		 * @param element 要素。
		 */
		void insert(iterator i, const PtrType& element) {
			if (element) {
				addRelation(*element, CloseRelationPtr(new CloseRelationImpl<ElementList>(
				                                           m_elements, m_elements.insert(i, element), this)));
			} else {
				m_elements.insert(i, element);
			}
		}

		/**
		 * 先頭に要素を追加します。
		 *
		 * @param element 要素。
		 */
		void push_front(const PtrType& element) {
			insert(begin(), element);
		}

		/**
		 * 末尾に要素を追加します。
		 *
		 * @param element 要素。
		 */
		void push_back (const PtrType& element) {
			insert(end(), element);
		}

	public:
		/**
		 * 全ての要素を削除します。
		 */
		void clear() {
			while (!empty()) {
				const PtrType& element = front();
				if (element) {
					element->release(*this);
				}
			}
		}
	};

}  // namespace Utility

#endif
